(function($) {
    'use strict';
    jQuery(document).ready(function($){

        // show add points link on cart page.
        if ( 1 == mwb_wpr.is_cart_redeem_enable ) {
            if ( jQuery('#mwb_par_button_to_add_points_section').length === 0 ) {

                setTimeout(() => {
                    if ( jQuery('#mwb_par_button_to_add_points_section').length === 0 ) {

                        jQuery('.wp-block-woocommerce-cart-order-summary-coupon-form-block').append('<div id="mwb_par_button_to_add_points_section"><a href="#">Add a points</a></div>');
                    }
                }, 1000);

                jQuery(document).on('mouseover', '.woocommerce-cart.woocommerce-page', function(){
                    if ( jQuery('#mwb_par_button_to_add_points_section').length === 0 ) {

                        jQuery('.wp-block-woocommerce-cart-order-summary-coupon-form-block').append('<div id="mwb_par_button_to_add_points_section"><a href="#">Add a points</a></div>');
                    }
                });
            }
        }

        // show add points link on checkout page.
        if ( 1 == mwb_wpr.is_checkout_redeem_enable ) {
            if ( jQuery('#mwb_par_button_to_add_points_section').length === 0 ) {

                setTimeout(() => {
                    if ( jQuery('#mwb_par_button_to_add_points_section').length === 0 ) {

                        jQuery('.wp-block-woocommerce-checkout-order-summary-coupon-form-block').append('<div id="mwb_par_button_to_add_points_section"><a href="#">Add a points</a></div>');
                    }
                }, 1000);

                jQuery(document).on('mouseover', '.woocommerce-checkout.woocommerce-page', function(){
                    if ( jQuery('#mwb_par_button_to_add_points_section').length === 0 ) {

                        jQuery('.wp-block-woocommerce-checkout-order-summary-coupon-form-block').append('<div id="mwb_par_button_to_add_points_section"><a href="#">Add a points</a></div>');
                    }
                });
            }
        }

        // Append Points apply section on cart and checkout page.
		jQuery(document).on('click', '#mwb_par_button_to_add_points_section', function(e){

			e.preventDefault();
			jQuery(this).hide();

			jQuery('.wp-block-woocommerce-cart-order-summary-coupon-form-block').append('<div class="mwb_wpr_apply_custom_points"><input type="number" name="mwb_cart_points" class="input-text" id="mwb_cart_points" value="" placeholder="Points"/><input type="button" name="mwb_cart_points_apply" data-point="" data-id="" class="button mwb_cart_points_apply" id="mwb_cart_points_apply" value="Apply Points"/></div>');
			jQuery('.wp-block-woocommerce-checkout-order-summary-coupon-form-block').append('<div class="mwb_wpr_apply_custom_points"><input type="number" name="mwb_cart_points" class="input-text" id="mwb_cart_points" value="" placeholder="Points"/><input type="button" name="mwb_cart_points_apply" data-point="" data-id="" class="button mwb_cart_points_apply" id="mwb_cart_points_apply" value="Apply Points"/></div>');
		});

        // Append remove html.
        if ( jQuery(document).find('#mwb_par_remove_applied_points').length === 0 ) {

            setTimeout(() => {
                if ( jQuery('#mwb_par_remove_applied_points').length === 0 ) {

                    jQuery(document).find('.wc-block-components-totals-fees__cart-discount').append('<div id="mwb_par_remove_applied_points"><a href="#">remove points</a></div>');
                }
            }, 1000);

            jQuery(document).on('mouseover', '.woocommerce-cart.woocommerce-page', function(){
                if ( jQuery('#mwb_par_remove_applied_points').length === 0 ) {

                    jQuery(document).find('.wc-block-components-totals-fees__cart-discount').append('<div id="mwb_par_remove_applied_points"><a href="#">remove points</a></div>');
                }
            });
        }

        // remove applied points here.
        $(document).on('click','.wc-block-components-totals-fees__cart-discount',function(e){
            if ( jQuery(document).find('#mwb_par_remove_applied_points').length > 0 ) {

                e.preventDefault();
                var data = {
                    action:'mwb_wpr_remove_cart_point',
                    mwb_nonce:mwb_wpr.mwb_wpr_nonce			
                };
                $.ajax({
                    url: mwb_wpr.ajaxurl, 
                    type: "POST",  
                    data: data,
                    dataType :'json',
                    success: function(response) 
                    {
                        if(response.result == true){
                            $('#mwb_cart_points').val('');
                        }
                    },
                    complete: function(){
                        location.reload();
                    }
                });
            }
        });

    });
})(jQuery);